#include "ti86asm.inc"
#include "asm86.h"

.org _asm_exec_ram
;-------------------------------------------------------------------------------------
;The Genetic Code
;By Will Dempster <wwd@zed80asm.org>
;For use in High School Biology
;
;
;
;
;History of The Genetic Code:
;
;23 November, 1999
;				  -- Version 1.1 Released
;				  -- Minor Interface Changes
;				  -- Added a new footer to the display screen
;				  -- Added a few comments
;2 November, 1999 
;				  -- Version 1.0 Released
;				  -- Version .75 Beta Released
;				  -- Version 0.5 Beta Released
;				  -- Search Database function Added
;				  -- Minor Bugfixes
;1 November, 1999 -- Version 0.1 beta released
;				  -- Horizontal Scrolling Implemented
;				  -- Minor Bug Found with vertical scrolling
;31 October, 1999 -- Version 0.01 alpha released
;				  -- Drew major interface functions
;				  -- Added a box around the current letter
;30 October, 1999 -- Project initiated
;				  -- Basic Algorithm conceived
;
;
;Bug Report:
;
;Currently no bugs are known with the current development version.
;If you find any bugs in this program, please email me at the aforementioned address
;
;Development Liscense:
;
;This program shall hereby be open source freeware under the TI Free Software Liscence.  No person is permitted to charge
;another individual for this program unless approved by the ORIGINAL CREATOR.  This source code
;and header must be with all distributions of the program.  If you would like to build on to the program
;you hereby have the right to do so.  All I ask is that you include this header and my name with the
;program so that due credit can be given.
;
;-------------------------------------------------------------------------------------

Start:							;Beginning loop
	call _runindicoff
	ld a,1					;  \
	ld (Pointer),a			;   \
	ld (OperationA),a		;	 Loads the Variables With 1
	ld (OperationB),a		;	/
	ld (OperationC),a		;  /
	call _clrLCD
	call _drawinterface		; draws the interface
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,String2
	call _vputs
Wait:						;Waits for a keypress
	call GET_KEY
	cp K_F1
	jp z,Begin
	cp K_F2
	jp z,help
	cp K_EXIT
	jp z,exit
	jp nz,Wait
help:						;Loop that displays help menu
	call _clrLCD
	call _drawinterface
	call _miniBox			;Draws mini-box
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,footer
	call _vputs
	ld a,15
	ld (_penCol),a
	ld a,17
	ld (_penRow),a
	ld hl,helptitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,Help1
	call _vputs
	ld a,31
	ld (_penRow),a
	ld a,16
	ld (_penCol),a
	ld hl,Help2
	call _vputs
	ld a,38
	ld (_penRow),a
	ld a,16
	ld (_penCol),a
	ld hl,Help3
	call _vputs
Wate:
	call GET_KEY
	cp K_EXIT
	jp z,Start
	jp nz,Wate
Begin:
	call _clrLCD
Test:					;tests where the pointer is pointing to
	ld a,(Pointer)
	cp 1				;Tests if it is 1
	call z,drawbox1		;Calls drawbox1 if the zero flag was set (condition true).
	cp 2				;tests if it is 2
	call z,drawbox2		;Calls drawbox2 if the zero flag was set (condition true).
	cp 3				;tests if it is 3
	call z,drawbox3		;calls drawbox3 if the zero flag was set (condition true).
Wte: 
	call GET_KEY
	cp K_UP
	call z,upVal
	cp K_DOWN
	call z,downVal
	cp K_LEFT
	call z,leftCurOne
	cp K_RIGHT
	call z,rightCurOne
	cp K_EXIT
	jp z,Start
	cp K_ENTER
	jp z,SumStuff
	jp nz,Test
SumStuff:
	call _clrLCD
Search:
	call _drawinterface
	call _miniBox
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,footer1
	call _vputs
	ld a,17
	ld (_penRow),a
	ld a,15
	ld (_penCol),a
	ld hl,Locater
	call _vputs
	ld a,(OperationA)
	cp 1
	call z,SearchA
	cp 2 
	call z,SearchG
	cp 3
	call z,SearchC
	cp 4
	call z,SearchU
Key_Press:
	call GET_KEY
	cp K_EXIT
	jp z,Start
	cp K_ENTER
	jp z,Begin
	jp nz,Key_Press
SearchA:
	xor a
	ld a,(OperationB)
	cp 1
	call z,SearchA_1
	cp 2
	call z,SearchA_2
	cp 3
	call z,DispThreonine
	cp 4
	call z,SearchA_4
	ld a,0
	ret
SearchG:
	xor a
	ld a,(OperationB)
	cp 1
	call z,SearchG_1
	cp 2
	call z,DispGlycine
	cp 3
	call z,DispAlanine
	cp 4
	call z,DispValine
	ld a,0
	ret
SearchC:
	xor a
	ld a,(OperationB)
	cp 1
	call z,SearchC_1
	cp 2
	call z,DispArginine
	cp 3
	call z,DispProline
	cp 4
	call z,DispLeucine
	ld a,0
	ret
SearchU:
	xor a
	ld a,(OperationB)
	cp 1
	call z,SearchU_1
	cp 2
	call z,SearchU_2
	cp 3
	call z,DispSerine
	cp 4
	call z,SearchU_4
	ld a,0
	ret
SearchU_1:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispStop
	cp 2
	call z,DispStop
	cp 3
	call z,DispTyrosine
	cp 4
	call z,DispTyrosine
	ld a,0
	ret
SearchU_2
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispStop
	cp 2
	call z,DispTryptophan	
	cp 3
	call z,DispCysteine
	cp 4
	call z,DispCysteine
	ld a,0
	ret
SearchU_4:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispLeucine
	cp 2
	call z,DispLeucine
	cp 3
	call z,DispPhenylilanine
	cp 4
	call z,DispPhenylilanine
	ld a,0
	ret
SearchC_1:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispGlutamine
	cp 2
	call z,DispGlutamine
	cp 3
	call z,DispHistidine
	cp 4
	call z,DispHistidine
	ld a,0
	ret
SearchA_1:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispLysine
	cp 2
	call z,DispLysine
	cp 3
	call z,DispAsparagine
	cp 4
	call z,DispAsparagine
	ld a,0
	ret
SearchA_2:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispArginine
	cp 2
	call z,DispArginine
	cp 3
	call z,DispSerine
	cp 4
	call z,DispSerine
	ld a,0
	ret
SearchA_4:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispIsoleucine
	cp 2
	call z,DispMethionine
	cp 3
	call z,DispIsoleucine
	cp 4
	call z,DispIsoleucine
	ld a,0
	ret
SearchG_1:
	xor a
	ld a,(OperationC)
	cp 1
	call z,DispGlutamicAcid
	cp 2
	call z,DispGlutamicAcid
	cp 3
	call z,DispAsparaticAcid
	cp 4
	call z,DispAsparaticAcid
	ld a,0
	ret
DispArginine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,ArgTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,ArgAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,ArgCode
	call _vputs
	ret
DispStop:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,StopTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,StopAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,StopCode
	call _vputs
	ret
DispTyrosine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,TyrTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,TyrAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,TyrCode
	call _vputs
	ret
DispTryptophan:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,TryTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,TryAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,TryCode
	call _vputs
	ret
DispCysteine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,CysTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,CysAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,CysCode
	call _vputs
	ret
DispPhenylilanine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,PhenTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,PhenAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,PhenCode
	call _vputs
	ret
DispProline:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,ProTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,ProAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,ProCode
	call _vputs
	ret
DispLeucine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,LeuTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,LeuAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,LeuCode
	call _vputs
	ret
DispGlutamine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,GluTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,GluAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,GluCode
	call _vputs
	ret
DispHistidine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,HisTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,HisAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,HisCode
	call _vputs
	ret
DispSerine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,SerTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,SerAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,SerCode
	call _vputs
	ret
DispIsoleucine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,IsoTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,IsoAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,IsoCode
	call _vputs
	ret
DispMethionine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,MethTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,MethAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,MethCode
	call _vputs
	ret
DispGlutamicAcid:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,GlutamicTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,GlutamicAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,GlutamicCode
	call _vputs
	ret
DispAsparaticAcid:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,AsparaticTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,AsparaticAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,AsparaticCode
	call _vputs
	ret
DispThreonine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,ThreoTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,ThreoAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,ThreoCode
	call _vputs
	ret
DispGlycine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,GlyTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,GlyAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,GlyCode
	call _vputs
	ret
DispAlanine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,AlaTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,AlaAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,AlaCode
	call _vputs
	ret
DispValine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,ValTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,ValAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,ValCode
	call _vputs
	ret
DispLysine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,LysTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,LysAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,LysCode
	call _vputs
	ret
DispAsparagine:
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,AspTitle
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,31
	ld (_penRow),a
	ld hl,AspAbr
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,38
	ld (_penRow),a
	ld hl,AspCode
	call _vputs
	ret
_drawinterface:
	ld a,2
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,String
	call _vputs
	ld bc,$fc00
	ld h,0
	ld l,0
	ld d,128
	ld e,0
	call FLine
	ld d,128
	ld e,0
	ld h,128
	ld l,64
	call FLine
	ld d,127
	ld e,63
	ld h,127
	ld l,0
	call FLine
	ld d,0
	ld e,63
	ld h,127
	ld l,63
	call FLine
	ld h,0
	ld l,9
	ld d,127
	ld e,9
	call FLine
	ld h,0
	ld l,55
	ld d,127
	ld e,55
	call FLine
	ret
_miniBox:
	ld bc,$fc00
	ld d,14
	ld e,16
	ld h,113
	ld l,16
	call FLine
	ld d,14
	ld e,46
	ld h,113
	ld l,46
	call FLine
	ld d,14
	ld e,16
	ld h,14
	ld l,46
	call FLine
	ld d,113
	ld e,16
	ld h,113
	ld l,46
	call FLine
	ld d,14
	ld e,23
	ld h,113
	ld l,23
	call FLine
	ret
drawbox1:
	call _drawinterface
	call _miniBox
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,footer
	call _vputs
	call _miniBox
	ld a,15
	ld (_penCol),a
	ld a,17
	ld (_penRow),a
	ld hl,BeginQuery
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,String3
	call _vputs
	ld bc,$fc00
	ld d,41
	ld e,39
	ld h,45
	ld l,39
	call FLine
Draw_Letters_1:
	ld a,32
	ld (_penRow),a
	ld a,42
	ld (_penCol),a
	call chkOpA
	ld a,49
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpB
	ld a,56
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpC
	ret
drawbox2:
	call _drawinterface
	call _miniBox
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,footer
	call _vputs
	call _miniBox
	ld a,15
	ld (_penCol),a
	ld a,17
	ld (_penRow),a
	ld hl,BeginQuery
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,String3
	call _vputs
	ld bc,$fc00
	ld d,48
	ld e,39
	ld h,52
	ld l,39
	call FLine	
Check_Letters_2:
	ld a,32
	ld (_penRow),a
	ld a,42
	ld (_penCol),a
	call chkOpA
	ld a,49
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpB
	ld a,56
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpC
	ret
drawbox3:
	call _drawinterface
	call _miniBox
	ld d,59
	ld e,39
	ld h,55
	ld l,39
	call FLine
	ld a,56
	ld (_penRow),a
	ld a,2
	ld (_penCol),a
	ld hl,footer
	call _vputs
	call _miniBox
	ld a,15
	ld (_penCol),a
	ld a,17
	ld (_penRow),a
	ld hl,BeginQuery
	call _vputs
	ld a,16
	ld (_penCol),a
	ld a,24
	ld (_penRow),a
	ld hl,String3
	call _vputs
Draw_Letters_3:
	ld a,32
	ld (_penRow),a
	ld a,42
	ld (_penCol),a
	call chkOpA
	ld a,49
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpB
	ld a,56
	ld (_penCol),a
	ld a,32
	ld (_penRow),a
	call chkOpC
	ret
leftCurOne:
	call _clrLCD
	ld a,(Pointer)
	dec a
	cp 0
	call z,incA
	ld (Pointer),a
	ld a,0
	ret
rightCurOne:
	call _clrLCD
	ld a,(Pointer)
	inc a
	cp 4
	call z,decA
	ld (Pointer),a
	ld a,0
	ret
incA:
	inc a
	ret
decA:
	dec a
	ret
DispA:
	ld hl,Astr
	call _vputs
	ret
DispG:
	ld hl,Gstr
	call _vputs
	ret
DispC:
	ld hl,Cstr
	call _vputs
	ret
DispU:
	ld hl,Ustr
	call _vputs
	ret
upVal:
	call _clrLCD
	ld a,(Pointer)
	cp 1
	call z,TraverseAUp
	cp 2
	call z,TraverseBUp
	cp 3
	call z,TraverseCUp
	ld a,0
	ret
downVal:
	call _clrLCD
	ld a,(Pointer)
	cp 1
	call z,TraverseADown
	cp 2
	call z,TraverseBDown
	cp 3
	call z,TraverseCDown
	ld a,0
	ret
TraverseAUp:
	ld a,(OperationA)
	inc a
	cp 5
	call z,decA
	ld (OperationA),a
	ld a,0
	ret
TraverseBUp:
	ld a,(OperationB)
	inc a
	cp 5
	call z,decA
	ld (OperationB),a
	ld a,0
	ret 
TraverseCUp:
	ld a,(OperationC)
	inc a
	cp 5
	call z,decA
	ld (OperationC),a
	ld a,0
	ret
TraverseADown:
	ld a,(OperationA)
	dec a
	cp 0
	call z,incA
	ld (OperationA),a
	ld a,0
	ret
TraverseBDown:
	ld a,(OperationB)
	dec a
	cp 0
	call z,incA
	ld (OperationB),a
	ld a,0
	ret
TraverseCDown:
	ld a,(OperationC)
	dec a
	cp 0
	call z,incA
	ld (OperationC),a
	ld a,0
	ret
chkOpA:
	ld a,(OperationA)
	cp 1
	call z,DispA
	cp 2
	call z,DispG
	cp 3
	call z,DispC
	cp 4
	call z,DispU
	ld a,0
	ret
chkOpB:
	ld a,(OperationB)
	cp 1
	call z,DispA
	cp 2
	call z,DispG
	cp 3
	call z,DispC
	cp 4
	call z,DispU
	ld a,0
	ret
chkOpC:
	ld a,(OperationC)
	cp 1
	call z,DispA
	cp 2
	call z,DispG
	cp 3
	call z,DispC
	cp 4
	call z,DispU
	ld a,0
	ret

;
; FASTLINE 1.0
;
; BRESENHAM'S LINE ALGORITHM
; by Jimmy Mrdell <yarin@acc.umu.se>
;
; Parameters:  BC    = memory area to draw line (usually $FC00)
;              DE,HL = coordinates of line (D,E)-(H,L)
;                      0 < D,H < 128, 0 < E,L < 64
;
; Code size:   145 bytes (excluding FindPixel)
;             
; Registers:   AF destroyed.
;
; Performance: 4 times faster than Stephane Jantzens line routine
;
;              Delta_X > Delta_Y  =>  innerloop =  98.50 T states
;              Delta_Y > Delta_X  =>  innerloop = 106.75 T states
;

FLine:
 push bc
 push de
 push hl
 push bc
 ld a,h
 cp d
 jr nc,DXpos
 ex de,hl
DXpos:
 ld b,d
 ld c,e
 pop de
 push hl
 call FindPixel
 add hl,de
 ex (sp),hl
 ld e,c
 ld c,a
 ld a,h
 sub b
 ld b,a
 ld a,l
 sub e
 ld de,16
 jr nc,DYpos
 neg
 ld de,-16
DYpos:
 push af
 sub b
 jr nc,DY_Greater
 add a,a
 neg
 ld (x_ai+1),a
 pop af
 add a,a
 ld (XDNeg+1),a
 sub b
 pop hl
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 bit 7,a
 jr nz,XDNeg
XNewRow:
 add hl,de
x_ai:
 sub 0
 push af
 rrc c
 jr nc,XNoWrap1
 inc hl
XNoWrap1:
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 dec b
 jr z,LineDone
 jr nc,XNewRow
XDNeg:
 add a,0
 push af
 rrc c
 jr nc,XNoWrap2
 inc hl
XNoWrap2:
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 dec b
 jr z,LineDone
 jr c,XNewRow
 jr XDNeg
DY_Greater:
 neg
 add a,a
 ld (YNoWrap+1),a
 ld a,b
 add a,a
 ld (YDNeg+1),a
 pop hl
 sub h
 ld b,h
 pop hl
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
YRepeat:
 bit 7,a
 jr nz,YDNeg
 rrc c
 jr nc,YNoWrap
 inc hl
YNoWrap:
 add a,0
 jr YPlot
YDNeg:
 add a,0
YPlot:
 add hl,de
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 djnz YRepeat
LineDone:
 pop hl
 pop de
 pop bc
 ret

;
; This is your default FindPixel routine. Can be exchanged with
; the famous Eble-Yopp... FindPixel routine.
;

FindPixel:
 push bc
 push de
 ld hl,ExpTable
 ld d,0
 ld a,b
 and $07
 ld e,a
 add hl,de
 ld e,(hl)
 ld h,d
 srl b
 srl b
 srl b
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,e
 ld e,b
 add hl,de
 pop de
 pop bc
 ret

ExpTable:
 .db $80,$40,$20,$10,$08,$04,$02,$01
exit:
	call _clrLCD
	ret
String:
	.db "The Genetic Code, By RavenMoss",0
String2:
	.db "F1- Convert   F2-Help   Exit-Exit",0
helptitle:
	.db "The Genetic Code -- Help",0
Help1:
	.db "This program translates a",0
Help2:
	.db "A Codon of RNA to its protein",0
Help3:
	.db "Equivalent.  (EXIT Returns)",0
footer:
	.db "Z80 AC- http://www.zed80asm.org",0
BeginQuery:
	.db "The Genetic Code -- Search",0
String3:
	.db "Use the selection pad below: ",0
Locater:
	.db "The Genetic Code -- Info",0
test:
	.db "Test",0
Astr:
	.db "A",0
Gstr:
	.db "G",0
Cstr:
	.db "C",0
Ustr:
	.db "U",0
ThreoTitle:
	.db "Threonine:",0
ThreoAbr:
	.db "Abreviation: THR",0
ThreoCode:
	.db "Amino Code: T",0
SerTitle:
	.db "Serine:",0
SerAbr:
	.db "Abreviation: SER",0
SerCode:
	.db "Amino Code: S",0
IsoTitle:
	.db "Isoleucine:",0
IsoAbr:
	.db "Abreviation: ILE",0
IsoCode:
	.db "Amino Code: I",0
MethTitle:
	.db "Methionine:",0
MethAbr:
	.db "Abreviation: MET",0
MethCode:
	.db "Amino Code: M",0
GlutamicTitle:
	.db "Glutamic Acid:",0
GlutamicAbr:
	.db "Abreviation: GLU",0
GlutamicCode:
	.db "Amino Code: E",0
AsparaticTitle:
	.db "Asparatic Acid:",0
AsparaticAbr:
	.db "Abreviation: ASP",0
AsparaticCode:
	.db "Amino Code: D",0
ArgTitle:
	.db "Arginine:",0
ArgAbr:
	.db "Abreviation: ARG",0
ArgCode:
	.db "Amino Code: R",0
GlyTitle:
	.db "Glycine",0
GlyAbr:
	.db "Abreviation: GLY",0
GlyCode:
	.db "Amino Code: G",0
AlaTitle:
	.db "Alanine:",0
AlaAbr:
	.db "Abreviation: ALA",0
AlaCode:
	.db "Amino Code: A",0
ValTitle:
	.db "Valine: ",0
ValAbr:
	.db "Abreviation: VAL",0
ValCode:
	.db "Amino Code: V",0
LysTitle:
	.db "Lysine:",0
LysAbr:
	.db "Abreviation: LYS",0
LysCode:
	.db "Amino Code: K",0
AspTitle:
	.db "Asparagine:",0
AspAbr:
	.db "Abreviation: ASN",0
AspCode:
	.db "Amino Code: N",0
ProTitle:
	.db "Proline:",0
ProAbr:
	.db "Abreviation: PRO",0
ProCode:
	.db "Amino Code: P",0
LeuTitle:
	.db "Leucine:",0
LeuAbr:
	.db "Abreviation: LEU",0
LeuCode:
	.db "Amino Code: L",0
GluTitle:
	.db "Glutamine:",0
GluAbr:
	.db "Abreviation: GLN",0
GluCode:
	.db "Amino Code: Q",0
HisTitle:
	.db "Histidine:",0
HisAbr:
	.db "Abreviation: HIS",0
HisCode:
	.db "Amino Code: H",0
StopTitle:
	.db "Stop Codon:",0
StopAbr:
	.db "Abreviation: Stop",0
StopCode:
	.db "Amino Code: N/A",0
TyrTitle:
	.db "Tyrosine:",0
TyrAbr:
	.db "Abreviation: TYR",0
TyrCode:
	.db "Amino Code: Y",0
TryTitle:
	.db "Tryptophan:",0
TryAbr:
	.db "Abreviation: TRP",0
TryCode:
	.db "Amino Code: W",0
CysTitle:
	.db "Cysteine:",0
CysAbr:
	.db "Abreviation: CYS",0
CysCode:
	.db "Amino Code: C",0
PhenTitle:
	.db "Phenylilanine:",0
PhenAbr:
	.db "Abreviation: PHE",0
PhenCode:
	.db "Amino Code: F",0
footer1:
	.db "Enter- Do Another || Exit-Main Menu",0
Pointer:
	.db 0
OperationA:
	.db 0
OperationB:
	.db 0
OperationC:
	.db 0
.end
